///////////////////////////////////////////////////////////
//                                                       //
//                 File: editwnd.cpp                     //
//               Author: Earl Fugate                     //
//                       Fall '97 EE499                  //
//                       UK IEEE Student Branch          //
//                                                       //
// Implementation of the team entry window for the       //
// 1999 IEEE SouthEast CON Hardware Design Competition   //
//                                                       //
///////////////////////////////////////////////////////////

#include "editwnd.h"
#include "teamlist.h"



extern TeamList _Global;
extern int _NumberofTeams;




EditWindow::EditWindow(PTWindowsObject AParent, LPSTR ATitle) :
  TWindow(AParent, ATitle)
{
  Static = new TStatic(this, -1, "Add Team Name:", 20, 20, 150, 24, 0);
  Edit1 = new TEdit(this, ID_EDIT1, "", 20, 40, 280, 20, 40, FALSE);
  ButtonAdd = new TButton(this, ID_BUTTONADD, "Add", 20, 80, 50, 30, FALSE);
  ButtonOk = new TButton(this, ID_BUTTONOK, "Close", 80, 80, 50, 30, FALSE);

  Attr.W = 320;
  Attr.H = 150;
  Attr.X = 100;
  Attr.Y = 120;

  EnableKBHandler();

}



void EditWindow::GetWindowClass( WNDCLASS& WndClass )
{


  TWindow::GetWindowClass( WndClass );
//WndClass.hbrBackground = CreateSolidBrush(RGB(200,200,200));
  WndClass.hIcon = LoadIcon( GetApplication()->hInstance, "ieee");
  WndClass.style = CS_NOCLOSE;
}


void EditWindow::HandleButtonAddMsg(RTMessage)
{

  int StartPos, EndPos;
  char TheText[MAX_TEXTLEN];

  // Handle notification messages from button
  Edit1->GetSelection(StartPos, EndPos);
  if ( StartPos == EndPos )
    Edit1->GetText(TheText, sizeof(TheText));
  else Edit1->GetSubText(TheText, StartPos, EndPos);

  Edit1->DeleteLine(-1);
  _Global.AddtoList(TheText);
  _NumberofTeams++;



}

void EditWindow::HandleButtonOkMsg(RTMessage)
{

  CloseWindow();

}

