///////////////////////////////////////////////////////////
//                                                       //
//                 File: remwnd.cpp                      //
//               Author: Earl Fugate                     //
//                       Fall '97 EE499                  //
//                       UK IEEE Student Branch          //
//                                                       //
// Implementation of the team removal window for the     //
// 1999 IEEE SouthEast CON Hardware Design Competition   //
//                                                       //
///////////////////////////////////////////////////////////



#include "ieee.h"

TeamList _Global;						// Holds data for teams
int _NumberofTeams = 0;
int _ScreenWidth;                                               // Holds value for screenwidth
int _ScreenHeigt;                                               // Holds value for screenheight
								// These two are used to scale
								// the windows at different
								// resolutions.


Ieee::Ieee( LPSTR ATitle, LPSTR MenuName )
	: TMDIFrame(ATitle, MenuName)

{
  _ScreenWidth = GetSystemMetrics(SM_CXSCREEN);                 // Grabs the system screen
  _ScreenHeigt = GetSystemMetrics(SM_CYSCREEN);               // dimensions.


}


void Ieee::GetWindowClass( WNDCLASS& WndClass )
{

  TMDIFrame::GetWindowClass( WndClass );
  WndClass.hIcon = LoadIcon( GetApplication()->hInstance, "IEEE");    	// Get the Icon for 
                                                                        // application.
}




void Ieee::SetupWindow()
{

  /* Sets up the timer for the multi windows */


  int Result;

  TMDIFrame::SetupWindow();
  Result = IDRETRY;
  while ((SetTimer(HWindow, 0, 50, NULL) == 0) && (Result == IDRETRY)) {
    Result = MessageBox(GetFocus(),"Could not Create Timer", "GDIDemo", MB_RETRYCANCEL);
  };
  if (Result == IDCANCEL)  PostQuitMessage(0);
};



void Ieee::CMCloseChildren(RTMessage)
{
// Close the children windows


  CloseChildren();

  ModifyMenu( GetMenu( HWindow ), CM_ROUND1, MF_BYCOMMAND | MF_ENABLED ,   	// Gray the menu
		CM_ROUND1, "Round 1" );                                         // options once
  ModifyMenu( GetMenu( HWindow ), CM_FINALS, MF_BYCOMMAND | MF_ENABLED ,        // selected.
		CM_FINALS, "Finals" );

  
}




void Ieee::Leader( TMessage& )
{
  /* Create the Leader Board Window. */

  GetApplication()->MakeWindow(new LeaderBoard(this, "Leader Board")); 

};



void Ieee::TrackWindow( TMessage& )
{
  /* Create the Track Window. */

  GetApplication()->MakeWindow(new Track(this, "Track"));
};


void Ieee::TitlWindow( TMessage& )
{
//  GetApplication()->MakeWindow(new TitleWindow(this, "IEEE South EastCON"));

};



void Ieee::FinalsTime( TMessage& )
{
//  GetApplication()->MakeWindow(new FinalWindow(this, "Final Round"));

};

  

void Ieee::Quit( TMessage& )
{


  CloseWindow();

};


void ChildTimers( Pvoid P, Pvoid)
{
  ((PTBaseDemoWindow)P)->TimerTick();
};

/* In response to WMTimer messages, each MDI child window's TimerTick
  Method is called. */

void Ieee::WMTimer( TMessage& )
{
  ForEach(ChildTimers, NULL);
};


void Ieee::WMDestroy( TMessage& Message )
{
  /* Release system from window control */

  KillTimer(HWindow, 0);
  TMDIFrame::WMDestroy(Message);
};





void Ieee::CM_Round1(TMessage& Msg)
{
   /* Start round one */
   TrackWindow(Msg);
   Leader(Msg);
   ModifyMenu( GetMenu( HWindow ), CM_ROUND1, MF_BYCOMMAND | MF_GRAYED,
		CM_ROUND1, "Round 1" );
   ModifyMenu( GetMenu( HWindow ), CM_FINALS, MF_BYCOMMAND | MF_GRAYED,
		CM_FINALS, "Finals" );


}


void Ieee::CM_AddTeam(TMessage&)
{
  /* Create add team window */

  GetApplication()->MakeWindow(new EditWindow(this, "Team Entry Form"));

}


void Ieee::CM_RemTeam(TMessage&)
{
  /* Create remove from list window */

  GetApplication()->MakeWindow(new RemWindow(this, "Remove Team"));

}




void Ieee::CM_Finals(TMessage& Msg)
{
  /* Start final round */

  TrackWindow(Msg);
  Leader(Msg);
  if(_NumberofTeams > 7)
	_Global.DeleteListFrom();

  ModifyMenu( GetMenu( HWindow ), CM_ROUND1, MF_BYCOMMAND | MF_GRAYED,
		CM_ROUND1, "Round 1" );
  ModifyMenu( GetMenu( HWindow ), CM_FINALS, MF_BYCOMMAND | MF_GRAYED,
		CM_FINALS, "Finals" );


} 


void Ieee::CM_About(TMessage&)
{
    char about[180] = "IEEE SouthEast CON 1999 Hardware Competition\n\n";
    strcat(about, "  Windows Programming: Earl Fugate\n");
    strcat(about, "  Scoring Engine: Scott Arrington\n");
    strcat(about, "  Port Driver: Keith Loiselle");

    MessageBox(HWindow, about, "About", MB_OK);
//  GetApplication()->MakeWindow(new AboutWindow(this, "About"));
//  MessageBox(HWindow, "IEEE SouthEastCon 1999 Design Team", "About", MB_OK);

}








/* TGDIDemoApp ------------------------------------------------------ */

_CLASSDEF(TGDIDemoApp)

class TGDIDemoApp : public TApplication
{
public:
	TGDIDemoApp(LPSTR name, HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    LPSTR lpCmd, int nCmdShow)  :
	      TApplication(name, hInstance, hPrevInstance, lpCmd, nCmdShow) {};
        virtual void InitMainWindow();

};

void TGDIDemoApp::InitMainWindow()
{
  /* Create a main window of type TGDIWindow. */
  MainWindow = new Ieee("IEEE SouthEast CON 1999", (LPSTR)MAKEINTRESOURCE(MenuID));
};

// Run the GDIDemoApp
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
		   LPSTR lpCmd, int nCmdShow)
{
    TGDIDemoApp GDIDemoApp("GDIApp", hInstance, hPrevInstance,
		                       lpCmd, nCmdShow);
    GDIDemoApp.Run();
    return GDIDemoApp.Status;
}
