///////////////////////////////////////////////////////////
//                                                       //
//                 File: remwnd.h                        //
//               Author: Earl Fugate                     //
//                       Fall '97 EE499                  //
//                       UK IEEE Student Branch          //
//                                                       //
// Implementation of the team removal window for the     //
// 1999 IEEE SouthEast CON Hardware Design Competition   //
//                                                       //
///////////////////////////////////////////////////////////

#ifndef _IEEE_H
#define _IEEE_H

// IEEE SouthEast Con program

#include <mdi.h>
#include <stdio.h>
#include "string.h"	// for strcpy and strcat
#include "demobase.h"
#include "leader.h"
#include "track.h"
#include "editwnd.h"
#include "teamlist.h"
#include "remwnd.h"


// Menu bar constants
const int MenuID            =  100;  // Resource ID of the menu
const int QuitID            =  100;  // File->Quit ID
const int CM_ROUND1	    =  101;
const int CM_FINALS	    =  102;
const int CM_ADDTEAM        =  103;
const int CM_REMTEAM	    =  104;
const int CM_ABOUT	    =  105;





/* Ieee --------------------------------------------------- */

_CLASSDEF(Ieee)

class Ieee : public TMDIFrame
{

private:



public:
         PTListBox ListBox;

	 Ieee( LPSTR ATitle, LPSTR MenuName );
         	 	  
	 virtual void SetupWindow();
         virtual void Leader( TMessage& ); 	   // = [CM_FIRST + LeaderBoardID];
	 virtual void TrackWindow( TMessage& );     //    = [CM_FIRST + TrackWindowID];
	 virtual void TitlWindow( TMessage& );
         virtual void FinalsTime( TMessage& );
	 virtual void CMCloseChildren(RTMessage Msg) = [CM_FIRST + CM_CLOSECHILDREN];


         virtual void Quit( TMessage& )             = [CM_FIRST + QuitID];
         virtual void WMTimer( TMessage& )          = [WM_FIRST + WM_TIMER];
         virtual void WMDestroy( TMessage& )        = [WM_FIRST + WM_DESTROY];

	 virtual void CM_AddTeam(TMessage&) = [CM_FIRST + CM_ADDTEAM];
	 virtual void CM_RemTeam(TMessage&) = [CM_FIRST + CM_REMTEAM];
	 virtual void CM_Round1(TMessage&) = [CM_FIRST + CM_ROUND1];
  	 virtual void CM_Finals(TMessage&) = [CM_FIRST + CM_FINALS];
         virtual void CM_About(TMessage&) = [CM_FIRST + CM_ABOUT];
	 virtual void GetWindowClass(WNDCLASS _FAR & AWndClass);

};



#endif