///////////////////////////////////////////////////////////
//                                                       //
//                 File: leader.cpp                      //
//               Author: Earl Fugate                     //
//                       Fall '97 EE499                  //
//                       UK IEEE Student Branch          //
//                 (incessant comments by Scott)         //
//                                                       //
// Implementation of the leader board and team display   //
// window for the 1999 IEEE SouthEast CON Hardware       //
// Design Competition software.                          //
// This shows the contestants, ranked by score.          //
//                                                       //
// Built on Borland's Object Windows Library ---  much   //
// of this code is dealing with that stuff.              //
//                                                       //
///////////////////////////////////////////////////////////


#include "leader.h"
#include "teamlist.h"
#include <stdio.h>


extern TeamList _Global;
extern int _NumberofTeams;
extern int _ScreenWidth;
extern int _ScreenHeigt;

BOOL EraseBackground;
int compare;
char Num[2];


/////////////////////////////////////////////////////
// constructor; performs loads of initializations...  
//
LeaderBoard::LeaderBoard( PTWindowsObject AParent, LPSTR ATitle ) :
	 TBaseDemoWindow(AParent, ATitle)
{
  int width = 300;
  int heigt = 440;

  if(_ScreenWidth == 800)
	{
	width = width * 1.25;
        heigt = heigt * 1.25;
	}


  Iconized = FALSE;
  Attr.W = width;
  Attr.H = heigt;
  Attr.X = 0;
  Attr.Y = 0;
  EraseBackground = FALSE;
  compare = 0;

}


void LeaderBoard::GetWindowClass( WNDCLASS& WndClass )
{
  TBaseDemoWindow::GetWindowClass( WndClass );
  WndClass.hbrBackground = CreateSolidBrush(0x0);
  WndClass.hIcon = LoadIcon( GetApplication()->hInstance, "IEEE");
  WndClass.style = CS_NOCLOSE;
}


////////////////////////////////////////////////
//  re-draw the window at every timeout; this is
//  removed because it flickers too much.
//
void LeaderBoard::Paint( HDC , PAINTSTRUCT& )
{
/*	HDC DC = GetDC(HWindow);

	TextOut(DC, 10, 20, _Global.GetfromList(0),
		strlen(_Global.GetfromList(0)));

	ReleaseDC(HWindow, DC);
*/
}


///////////////////////////////////////////
// yet another window-drugery function
//
void LeaderBoard::WMSize( TMessage &Message )
{
  TBaseDemoWindow::WMSize( Message );
  if (IsIconic(HWindow)) {
    if (!Iconized) {
     
      Iconized = TRUE;
     
    };
  } else {
    if (Iconized) {
     
      Iconized = FALSE;
    };
  };
}


//////////////////////////////////////////////////////
//  The main loop for the window.
//
void LeaderBoard::TimerTick()
{

    char Temp[10];
    
    if (IsIconic(HWindow)) {
      /* Iconized windows don't process paint messages, so we'll manually
       * update the image here.  Doing this painting during the timer tick
       * will slow things down a bit, especially with several of these
       * windows iconized at the same time.
       */

    }
    else {
      // this is the normal case

      if (compare != _NumberofTeams)
      {	
	compare = _NumberofTeams;
	EraseBackground = TRUE;
      }

      // do some graphics stuff

      InvalidateRect(HWindow, NULL, EraseBackground);
      EraseBackground = FALSE;

      HDC DC = GetDC(HWindow);

      SetBkColor(DC, RGB(0, 0, 0));
      SetTextColor(DC, RGB(255, 255, 255));
      
      // show the list of teams and their scores, if there are any
      if(_NumberofTeams > 0)
      {
	for(int index = 0; index < _NumberofTeams; index++)
                {
		sprintf(Temp, "%3.1f    %03d",
			_Global.GetScore(index),
			_Global.GetTime(index), 10);
		TextOut(DC, 200, 10 + (index * 16), Temp, strlen(Temp));
		TextOut(DC, 10, 10 + (index *	16), _Global.GetfromList(index),
			strlen(_Global.GetfromList(index)));
		}

      }  /*  end  if(_NumberofTeams > 0 ) */

      ReleaseDC(HWindow, DC);
      

    }  /*  end  if (IsIconic(HWindow))*/
 
}  /* end of LeaderBoard::TimerTick() */

