///////////////////////////////////////////////////////////
//                                                       //
//                 File: remwnd.cpp                      //
//               Author: Earl Fugate                     //
//                       Fall '97 EE499                  //
//                       UK IEEE Student Branch          //
//                                                       //
// Implementation of the team removal window for the     //
// 1999 IEEE SouthEast CON Hardware Design Competition   //
//                                                       //
///////////////////////////////////////////////////////////

#include "remwnd.h"
#include <button.h>
#include "teamlist.h"

#include <stdio.h>

extern TeamList _Global;
extern int _NumberofTeams;
int AnyMore = 0;
int IdIndex;


RemWindow::RemWindow(PTWindowsObject AParent, LPSTR ATitle) :
  TWindow(AParent, ATitle)
{
  ListBox = new TListBox(this, ID_LISTBOX, 20, 20, 320, 100);
  Attr.W = 450;
  Attr.H = 170;
  Attr.X = 100;
  Attr.Y = 120;

  new TButton(this, ID_BUTTON1, "Remove", 360, 30, 70, 30, FALSE);
  new TButton(this, ID_BUTTON2, "OK", 360, 80, 70, 30, FALSE);

  IdIndex = 0;

}


void RemWindow::GetWindowClass( WNDCLASS& WndClass )
{


  TWindow::GetWindowClass( WndClass );
  WndClass.hIcon = LoadIcon( GetApplication()->hInstance, "IEEE");
  WndClass.style = CS_NOCLOSE;

}


void RemWindow::SetupWindow()
{
  TWindow::SetupWindow();
  if ((_NumberofTeams > 0)  && (AnyMore != _NumberofTeams))
	{
	for(int count = 0; count < _NumberofTeams; count++)
        	DataPutIn(count);

	}



}


void RemWindow::DataPutIn(int index)
{
  ListBox->InsertString(_Global.GetfromList(index), index);

}
  


void RemWindow::HandleListBoxMsg(RTMessage Msg)
{

  if ( Msg.LP.Hi == LBN_SELCHANGE )
    IdIndex = ListBox->GetSelIndex();


}


void RemWindow::WMSetFocus(RTMessage)
{
  SetFocus(ListBox->HWindow);
}


void RemWindow::HandleButtonMsg(RTMessage)
{
  _Global.RemovefromList(IdIndex);
  ListBox->ClearList();
  SetupWindow();
  
}


void RemWindow::HandleOkButtonMsg(RTMessage)
{
  CloseWindow();
}
