///////////////////////////////////////////////////////////
//                                                       //
//                 File: remwnd.h                        //
//               Author: Earl Fugate                     //
//                       Fall '97 EE499                  //
//                       UK IEEE Student Branch          //
//                                                       //
// Implementation of the team removal window for the     //
// 1999 IEEE SouthEast CON Hardware Design Competition   //
//                                                       //
///////////////////////////////////////////////////////////

#ifndef _REMWND_H
#define _REMWND_H


#include <owl.h>
#include <window.h>
#include <listbox.h>

const WORD ID_LISTBOX = 101;
const WORD ID_BUTTON1 = 102;
const WORD ID_BUTTON2 = 103;


class RemWindow : public TWindow
{
public:
  PTListBox ListBox;

  RemWindow(PTWindowsObject AParent, LPSTR ATitle);
  virtual void SetupWindow();
  void DataPutIn(int);

  virtual void HandleListBoxMsg(RTMessage Msg)
    = [ID_FIRST + ID_LISTBOX];
  virtual void WMSetFocus(RTMessage Msg) =
    [WM_FIRST + WM_SETFOCUS];

  virtual LPSTR GetClassName() { return "Remove Team"; };
  virtual void GetWindowClass( WNDCLASS& WndClass );

  virtual void HandleButtonMsg(RTMessage Msg)
			= [ID_FIRST + ID_BUTTON1];
  virtual void HandleOkButtonMsg(RTMessage Msg)
			= [ID_FIRST + ID_BUTTON2];

};


#endif