///////////////////////////////////////////////////////////
//                                                       //
//                 File: select.cpp                      //
//               Author: Earl Fugate                     //
//                       Fall '97 EE499                  //
//                       UK IEEE Student Branch          //
//                                                       //
// Implementation of the team selection window for the   //
// 1999 IEEE SouthEast CON Hardware Design Competition   //
//                                                       //
///////////////////////////////////////////////////////////



#include <button.h>
#include "select.h"
#include "Teamlist.h"

extern TeamList _Global;                     		// Get access to team list
extern int _NumberofTeams;
extern int TrackATeam, TrackBTeam;                      // Team ids for tracks

int GetMore = 0;
int Index;


SelectTeams::SelectTeams(PTWindowsObject AParent, LPSTR ATitle) :
  TWindow(AParent, ATitle)
{
  /* Setup the window and its attributes */

  ListBox = new TListBox(this, ID_LISTBOX, 20, 20, 320, 100);
  Attr.W = 450;
  Attr.H = 170;
  Attr.X = 100;
  Attr.Y = 120;

  // Set up the window buttons
  new TButton(this, ID_BUTTONTRCKA, "Track A", 360, 30, 70, 30, FALSE);
  new TButton(this, ID_BUTTONTRCKB, "Track B", 360, 70, 70, 30, FALSE);
  new TButton(this, ID_BUTTONOK, "OK", 360, 110, 70, 30, FALSE);

  Index = 0;

}


void SelectTeams::GetWindowClass( WNDCLASS& WndClass )
{
  // Get attributes for the window

  TWindow::GetWindowClass( WndClass );
  WndClass.hIcon = LoadIcon( GetApplication()->hInstance, "IEEE");
  WndClass.style = CS_NOCLOSE;

}


void SelectTeams::SetupWindow()
{
  TWindow::SetupWindow();

  // Places the team names into the selection window

    if ((_NumberofTeams > 0)  && (GetMore != _NumberofTeams))
	{
	for(int count = 0; count < _NumberofTeams; count++)
        	DataPutIn(count);

	}



}


void SelectTeams::DataPutIn(int index)
{
  // Places names into the listbox

  ListBox->InsertString(_Global.GetfromList(index), index);

}
  


void SelectTeams::HandleListBoxMsg(RTMessage Msg)
{
  // See if any names have been selected and get their ids

  if ( Msg.LP.Hi == LBN_SELCHANGE )
    Index = ListBox->GetSelIndex();


}


void SelectTeams::WMSetFocus(RTMessage)
{
  SetFocus(ListBox->HWindow);
}



void SelectTeams::HandleButtonTrckAMsg(RTMessage)
{
  // Set the selection team id to the id for the track A competitor
  TrackATeam = Index;
}



void SelectTeams::HandleButtonTrckBMsg(RTMessage)
{
  // Set the selection team id to the id for the track B competitor
  TrackBTeam = Index;
}


void SelectTeams::HandleButtonOkMsg(RTMessage)
{
  // Check for the OK Button and close out the window
  CloseWindow();

}







