///////////////////////////////////////////////////////////
//                                                       //
//                 File: teamlist.cpp                    //
//              Authors: Earl Fugate and                 //
//                       Scott Arrington                 //
//                       Fall '97 EE499                  //
//                       UK IEEE Student Branch          //
//                                                       //
// Implementation of the class TeamList for the          //
// 1999 IEEE SouthEast CON Hardware Design Competition   //
//                                                       //
//                                                       //
// This is the class that stores and manipulates the     //
// data pertaining to the contestant teams.  It works    //
// very closely with the ScoringEngine and the track     //
// window...
//                                                       //
///////////////////////////////////////////////////////////
#include "teamlist.h"

extern _NumberofTeams;

////////////////////////////////////////////
//  constructor
//     create and nullify the list of teams.
//
TeamList::TeamList()
{
	for(int i = 0; i <= 40; i++)
		{
		strcpy(&_holder[i][0], "");
		_score[i] = 0;
                }

	_index = 0;
	strcpy(&_holder[40][0], "No Team Selected!");
	_score[40] = 0;
	_time[40] = 0;

}



///////////////////////////////////////////////
//  add another name to the name array
//
void TeamList::AddtoList(char* temp)
{
  	strcpy(&_holder[_index][0], temp);
	_index++;
}


///////////////////////////////////////////////////
//  get the name of the team with index number input
//
char* TeamList::GetfromList(int input)
{
	return &_holder[input][0];
}


/////////////////////////////////////////
// delete a given team from the list
// 
void TeamList::RemovefromList(int index)
{
	if(_NumberofTeams != 0)
        {
                
		if(_NumberofTeams > 1)
        	{

	   	for(int count = index; count < _NumberofTeams; count++)
			strcpy(&_holder[count][0], &_holder[count + 1][0]);
	    		strcpy(&_holder[count][0], "");
                        
		}

		else
			strcpy(&_holder[0][0], "");

	RemovefromScoreList(index);
        RemovefromTimeList(index);
	_NumberofTeams--;
        _index--;
        }
	
}  /*  end of RemovefromList() */


////////////////////////////////////////////////////////
//  you guessed it, this keeps the top 8 competitors for
//  the final round!
//
void TeamList::DeleteListFrom(void)
{
	for(int count = 8; count < _NumberofTeams; count++)
		strcpy(&_holder[count][0], "");

	_NumberofTeams = 8;
        _index = 8;

}


/////////////////////////////////////////////////////////////
//  subfunction to remove a team's entry from the score array
//
void TeamList::RemovefromScoreList(int index)
{

	if(_NumberofTeams != 0)
        {
                
		if(_NumberofTeams > 1)
        	{

	   	for(int count = index; count < _NumberofTeams; count++)
			_score[count] = _score[count + 1];
	    		_score[count] = 0;
                        
		}

		else
			_score[0] = 0;

	}
	
}   /*  end of  RemovefromScoreList()  */ 


///////////////////////////////////////////////////////////
//  subfunction to remove a team's entry in the time array
//
void TeamList::RemovefromTimeList(int index)
{

	if(_NumberofTeams != 0)
        {
                
		if(_NumberofTeams > 1)
        	{

	   	for(int count = index; count < _NumberofTeams; count++)
			_time[count] = _time[count + 1];
	    		_time[count] = 0;
                        
		}

		else
			_time[0] = 0;

	}
	
}  /* end of RemovefromTimeList()  */


///////////////////////////////////////////////////////
//  sort the list of teams by score.  if there is a tie
//  in score, sort those ties by time.
//
void TeamList::SortScores(void)
{
	scoretype temp = 0;
	char ctemp[40];
        int ttemp = 0;

	for(int index = 0; index < _NumberofTeams; index++)
		{
		for(int count = index; count <= _NumberofTeams; count++)
			{
			if(_score[index] < _score[count])
				{
				temp = _score[index];
				_score[index] = _score[count];
				_score[count] = temp;

				strcpy(&ctemp[0], &_holder[index][0]);
				strcpy(&_holder[index][0], &_holder[count][0]);
				strcpy(&_holder[count][0], &ctemp[0]); 

				ttemp = _time[index];
				_time[index] = _time[count];
				_time[count] = ttemp;

				}

			if(_score[index] == _score[count])
				if(_time[index] < _time[count])
					{
					temp = _time[index];
					_time[index] = _time[count];
					_time[count] = temp;

					temp = _score[index];
					_score[index] = _score[count];
					_score[count] = temp;
                        	
					strcpy(&ctemp[0], &_holder[index][0]);
					strcpy(&_holder[index][0], &_holder[count][0]);
					strcpy(&_holder[count][0], &ctemp[0]); 
                                        }

			}

		}

}   /*  end of  TeamList::SortScores() */


//  end of teamlist.cpp