///////////////////////////////////////////////////////////
//                                                       //
//                 File: track.cpp                       //
//               Author: Earl Fugate                     //
//              Hackers: Keith and Scott                 //
//                       Fall '97 EE499                  //
//                       UK IEEE Student Branch          //
//                                                       //
// Definitions and #defines for the track window of      //
// 1999 IEEE SouthEast CON Hardware Design Competition   //
// The competition takes place here.                     //
//                                                       //
// Built on Borland's Object Windows Library ---  much   //
// of this code is dealing with that stuff.              //
//                                                       //
///////////////////////////////////////////////////////////

#ifndef __TRACK_H
#define __TRACK_H

#include "demobase.h"
#include <button.h>

const WORD ID_BUTTONSTART = 105;
const WORD ID_BUTTONSTOP  = 106;
const WORD ID_BUTTONRESET = 107;
const WORD ID_BUTTONTEAMS = 108;


_CLASSDEF(Track)

class Track : public TBaseDemoWindow
{
public:
	 Track(PTWindowsObject AParent, LPSTR ATitle);
	 HBITMAP Blank, Over[8];
	 int XX, YY;
	 TButton *ButtonStart, *ButtonStop, *ButtonTeam, *ButtonReset;

         virtual LPSTR GetClassName() { return "Track"; };
         virtual void GetWindowClass( WNDCLASS& WndClass );
	 virtual void Paint( HDC , PAINTSTRUCT& );
	 virtual void TimerTick();
         virtual void WMSize( TMessage &Message ) = [WM_FIRST + WM_SIZE];
	 virtual void DrawBMP( HDC DC, int X, int Y, HBITMAP BitMap );
	 virtual void StoppingFunction(void);

	 virtual void WMLButtonDown(RTMessage Msg)
    		= [WM_FIRST + WM_LBUTTONDOWN];
	 virtual void ButtonStartMsg(RTMessage)
		= [ID_FIRST + ID_BUTTONSTART];
	 virtual void ButtonStopMsg(RTMessage)
		= [ID_FIRST + ID_BUTTONSTOP];
	 virtual void ButtonSelectMsg(RTMessage)
		= [ID_FIRST + ID_BUTTONTEAMS];
	 virtual void ButtonResetMsg(RTMessage)
		= [ID_FIRST + ID_BUTTONRESET];


private:
	 BOOL Iconized;
};

#endif // ifndef __LINE_H
